# CSC 111: Day 13
# Author: Sara Mathieson and CSC 111 class (9am section)
# A program to compute the range of a list (in the mathematical sense)
# Makes use of helper functions minimum and maximum


# compute and return the minimum value of a list
def minimum(lst):
    my_min = lst[0] # first assignment of my_min

    # way (1) of iterating over a list
    for i in range(len(lst)): # i is the index
        if lst[i] < my_min:
            my_min = lst[i] # update my_min

    # way (2) of iterating over a list
    '''for l in lst: # l is an element of the list
        if l < my_min:
            my_min = l # reassign my_min'''

    return my_min # here is where we "give back" the value of my_min


# compute and return the maximum value of a list
# we copy and pasted minimum and changed the variable names and < to >
def maximum(lst):
    my_max = lst[0] # first assignment of my_max

    for i in range(len(lst)): # i is the index
       if lst[i] > my_max:
           my_max = lst[i]
           
    return my_max


# using minimum(...) and maximum(...), return the range
def lst_range(lst):
    my_min = minimum(lst) # call helper function
    my_max = maximum(lst) # call helper function
    r = my_max - my_min
    return r


# in the main method, test our our functions
def main():

    my_lst = [17, 10, 1, 12, 5, 18, 15, 16, 6, 14]

    # commenting out my testing at the very end
    '''my_min = minimum(my_lst)
    print(my_min)
    my_max = maximum(my_lst)
    print(my_max)'''

    # this is what I really wanted to do all along
    r = lst_range(my_lst)
    print("Range is",r)


main()
